#include <stdio.h>
#include <pico/stdlib.h>

#include "pico/binary_info.h"
#include "hardware/i2c.h"

#include "ardu.h"
 

//----I2C-------
i2c_inst_t *XXi2c = i2c0;		//i2c1 para 26-27   12c0 para 0-1 ...
#define	SDA_PIN 0
#define	SCL_PIN 1
//-------------------------
void scanI2C(void);

#include "ole.h"
char miBuffer[40];

#define MILED 25

int main()
{
	stdio_init_all();
	delay(1000);
	printf("-----------------------\n");
	printf("----Hola SENSORES------\n");
	pinMode(MILED, OUTPUT);
	
	//INIT --I2C--
	printf("SDA=%d  SDL=%d \n", SDA_PIN, SCL_PIN);
    i2c_init(i2c_default, 100000);
    gpio_set_function( SDA_PIN, GPIO_FUNC_I2C);
    gpio_set_function( SCL_PIN, GPIO_FUNC_I2C);
    gpio_pull_up( SDA_PIN);
    gpio_pull_up( SCL_PIN);
    bi_decl(bi_2pins_with_func( SDA_PIN,  SCL_PIN, GPIO_FUNC_I2C));
    
    scanI2C(); 
    OleInit();  
//---------------------------
	
	while(1)
	{
	  printf("Estado %d\n",0);
	  digitalWrite(MILED, LOW);
	  delay(500);
	  printf("Estado %d\n",1);
	  digitalWrite(MILED, HIGH);
	  xclearDisplay();
	  StringAT(0,0,"--SETA43--"); 
	  printf("_OLED_\n");
	  printf("-----------------------\n");
	  delay(2000);
	 
	}
}



//-----------I2C--------------------
void scanI2C(void)
{
 int ret;
 uint8_t rxdata;
 unsigned char addr;
 
	printf("------nI2C Bus Scan--\n");
    for ( addr= 0; addr < 255; ++addr) 
    {
     ret = i2c_read_blocking(XXi2c, addr, &rxdata, 1, false);
	 if(ret>0) printf("I2C DIRECCION=%d=%#04X %d Data=%d\n",addr,addr,ret, rxdata);	
	}
	printf("-----------------------\n");
}




